// Definizione e testing una funzione che restituisce il
// massimo di una sequenza non vuota di numeri interi non
// negativi terminata da un intero negativo.

// inclusione dell'header file della libreria standard di
// definizioni di macro, costanti e dichiarazioni di funzioni e tipi
// per le varie operazioni di input/output

#include <stdio.h>

// Definizione della funzione

int posMassimoSeq()
   {
   // variabile per il massimo corrente;
   int max;

   // variabile per i valori della sequenza
   int valore;
   
   // variabile per la posizione del massimo corrente
   int pos_max;
   
   // variabile per la posizione corrente nella sequenza
   int pos;

   // acquisisco il primo valore
   printf("\nDammi il primo valore: ");
   scanf("%d", &valore);

   // inizializzo il massimo con il primo valore acquisito.
   // Potrei inizializzarlo con 0, il minimo valore che puo'
   // comparire nella squenza, ma la soluzione sarebbe meno
   // generale
   max = valore;
   
   // inizializzo la posizione del massimo corrente
   // la posizione nella sequenza a 1
   pos = 1;
   pos_max = 1;

   // continuo fino al primo valore
   // negativo
   while (valore >= 0)
      {
	  // acquisisco il prossimo valore
      printf("\nDammi il prossimo valore: ");
      scanf("%d", &valore);
	  
	  // aggiorno la posizione all'interno della sequenza
	  pos = pos + 1;
	  
	  // se il valore appena letto costituisce il massimo corrente
	  if (valore > max)
	    {
		// aggiorno il valore del massimo corrente e la sua posizione
		pos_max = pos; 
		max = valore;
		};
      };

   // restituisco la posizione del massimo corrente
   return(pos_max);
   }

// Testing della funzione

int main()
   {
   // calcolo e visualizzo il massimo valore della sequenza
   printf ("\nLa posizione del massimo valore della sequenza e' %d \n",
               posMassimoSeq());

   return(1);
   }
 